/* Aug 2001 JTdidit jt@jt-mj.net */
lev='0.0.6'
level = lev '10 Dec 2001'
/* tnailer.cmd - jt program to build both thumbnails and html for
   clickable images that show the fullsize image */

   
/* parmfile spec:
   if parmfile is set here, it is assumed to be a filespec for
   a default param file (which can be overriden by a command line argument 
   -p=<filespec>
   and any values in the file will overwrite the default param block below
*/

parmfile='g:\rexx\JT\tnailer.prm'

 

/* --------------------------------------------------------------*/
/*  default parameter block - edit carefully */
/*  these values used if no param file is specified on the cmd line 
    or as default above.  For usage, see tnailer.txt */
params.ftypes="*.jpg *.jpeg"
params.outfile="tnails.htm"
params.tnq=75
params.maxwidth=150
params.maxheight=200
params.halfmax=.60
params.qmax=.25
params.emax=.125
params.target='Fullsize'
params.border=2
params.tnailpref='tn-'
params.tnailsuf=''
params.reprocess=0
/* end of default parameter block. You shouldn't edit anything below this */
/* --------------------------------------------------------------*/

call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
call SysLoadFuncs

Say 'tnailer.cmd version' level
say 'Usage is tnailer ? for info or tnailer [-p=parmfilespec] [imagedir]'


parse arg argstr
if argstr='?' then do
   say ''
   say 'For each .jpg file in the current [or source] directory, creates a'
   say 'new file scaled as a thumbnail, if the file dimensions exceed'
   say 'values set as parameters, which come from file specified'
   say 'as -p=<filespec> on command line or defaults set in program.'
   say 'See default param file for settings. Operation:'
   say 'File wxyz.jpg produces TN-wxyz.jpg (you can specify a'
   say 'prefix and or a suffix for the thumbnails) in the current directory,' 
   say 'For each .jpg file in the current [or source] directory, creates a'
   say 'new file scaled as a thumbnail, if the file dimensions exceed'
   say 'values set in the parameter block. File wxyz.jpg produces'
   say 'TN-wxyz.jpg (you can specify a prefix and or a suffix for the'
   say 'thumbnails) in the current directory,' 
   say  'which should be HPFS or otherwise able to use long filenames.'
   say ''
   say 'Also builds in the current directory an html file:' params.outfile
   say 'with code fragments to make the thumbnails clickable to' 
   say 'open a window with the fullsize file.'
   say ''
   exit
   end 

argstr=translate(argstr)
parse var argstr p1 p2 .
if left(p1,3)='-P=' then do
   where=p2
   parmfile=substr(p1,4)
   end

   else   where=p1


   
if parmfile<>'' then do
    pfe=stream(parmfile,'C','QUERY EXISTS')
    if pfe='' then do
       say 'parmfile' parmfile 'not there or invalid;'
       say 'terminating program.'
       exit
       end
    call readparms   
    end

if params.tnailpref='' & params.tnailsuf='' then do
   say 'You must define either a prefix or a suffix for the'
   say 'thumbnail files to distinguish them from the originals.'
   say 'Terminating program.'
   exit
   end

if params.tnailpref='' & params.reprocess=0 then do
   say 'reprocess flag set to 0 but no prefix'
   say 'overriding flag setting'
   params.reprocess=1
   end
                                                                                  
here=directory()
if right(here,1)='\' then here=left(here,length(here)-1)
   
if where='' then do
    fullpath=0
    where=here
    end
  else do
    fullpath=1
    if pos('\',where)=0 then where=here||'\'||where
    end

xx = stream(params.outfile,C,'query exists')
    if xx<>'' then do
    say 'Output file' params.outfile 'exists'
    say 'Press Enter to replace it; X to quit'
    yy=linein()
    if yy<>'' then exit
    xx=sysfiledelete(params.outfile)
    end
                                
do while queued()>0
   pull junk
   end

if where \= here then xxx=directory(where)
 '@dir /B' params.ftypes '2> NUL | RXQUEUE'
if where \= here then xxx=directory(here)

if substr(where,length(where))='\' then where=left(where,length(where)-1)

if queued()=0 then do
   say 'No files to process'
   exit
   end

call charout,'Working'

j=1
do while queued()>0
    parse pull files.j
    if params.lc=1 then do
       files.j=translate(files.j,"ABCDEFGHIJKLMNOPQRSTUVWXYZ","abcdefghijklmnopqrstuvwxyz")
       end
    j=j+1
    end
files.0=j-1

      
xx=stream(params.outfile,C,'open write')

header.0=14
header.1='<HTML>'
header.2='<HEAD>'
header.3='<TITLE>Image thumbnails in' where '</TITLE><BR>'
header.4=''  /*<BASE TARGET='||params.target||'>' */
header.5='</HEAD><BODY>'
header.6='<h1>TNAILER.CMD' lev '(by Julian Thomas) did this</h1>'
header.7='on' date() 'at' time()||'.'
header.8='<P><FONT SIZE="-2">Size is width * height</FONT><P>'
header.9="<p>This page, while viewable, is not intended for direct"
header.10="use on the web.  The purpose is to generate"
header.11="thumbnails and the html code for clickable thumbnails"
header.12="as an aid for html creation."
header.13="You can click on one here to see how it works."
header.14="<p><center>"


do i=1 to header.0
   xx= lineout(params.outfile, header.i)
   end

call putqueue
call lineout params.outfile, '</HTML>'
call lineout params.outfile
say ''
say 'TNAILER is finished.'
exit

putqueue: 

i=0
do j=1 to files.0 by 1
   call charout,'.'
   filenam = files.j
   if fullpath = 0 then do
      fullname=filenam
      linkname=filenam
      end
   else do
       fullname=where||'\'||filenam
       linkname=fullname
       do while pos('\',linkname)>0
          zz=pos('\',linkname)
          linkname=left(linkname,zz-1)||'/'||substr(linkname,zz+1)
	     end /* change \ to / loop */
       if substr(linkname,2,1)=':' then
              linkname='file:///'||left(linkname,1)||'|'||substr(linkname,3)
       end  /* rebuild linkname */
   qdot=lastpos('.',filenam)
   ext=translate(substr(filenam,qdot+1))
   filesize=stream(fullname,'C','QUERY SIZE')
   siz=''

if params.reprocess=0 & pos(params.tnailpref,filenam)=1 then say 'skipping' filenam
if params.reprocess=0 & pos(params.tnailpref,filenam)=1 then iterate

   
   /*  if ext='GIF' then do
        call gifsize
        end 
 else if ext='PNG' then do
       call pngsize
       end
 */
      if ext='JPG' | ext='JPEG' then do
       call jpgsize fullname
       end
                 
    else do
       say 'skipping unsupported file type' fullname
       iterate
       end

       if width>0 then siz=width||'x'||height
          else do
          say 'bad size values for file' fullname ';skipping file'
          iterate
          end

/* see if we use it as is or need to scale it */

wx=params.maxwidth/width
   hx=params.maxheight/height
   scale=min(wx,hx)

if scale>=params.halfmax then do /*   it's ok as is */
   ws=width
   hs=height
   scale=1
   call lineout params.outfile, ''
   call lineout params.outfile, '<p>'
   outlin='<IMG SRC="'
   outlin=outlin||linkname||'"'
   call lineout params.outfile,outlin
   call lineout params.outfile,' ALT="'||filenam||'"'
   outlin='WIDTH='||ws
   outlin=outlin 'HEIGHT='||hs||' BORDER='||params.border||'>'
   call lineout params.outfile, outlin
   outlin='<br>' filenam 'size=' width '*' height
   outlin=outlin||';' filesize 'bytes'
   call lineout params.outfile, outlin
   call lineout params.outfile,"<br>This image is full size"
   call lineout params.outfile,''   

   end


   else do    /* we need to scale the image */
               
/*here we need to actually make the thumbnail and then get its wi and h */
   wbig=width
   hbig=height
   
   if scale<=params.emax then scalex='1/8'
   else if scale<=params.qmax then scalex='1/4'
   else scalex='1/2'
   qq=pos('.',filenam)
   tfn=params.tnailpref||left(filenam,qq-1)||params.tnailsuf
   tfe=substr(filenam,qq)
   tfn=tfn||tfe

'@outjpeg /q='||params.tnq '/s='||scalex '/m=F' fullname '>' tfn

/*  get dimensions now */
   call jpgsize tfn

/*width, height are not those of the THUMBNAILfile  */

   call lineout params.outfile, ''
   call lineout params.outfile, '<p>'
   outlin='<A HREF="'||linkname||'"'
   if params.target <>'' then  outlin=outlin 'TARGET="'||params.target||'">'
      else outlin=outlin||'>'
   call lineout params.outfile,outlin
   outlin='<IMG SRC="'
   outlin=outlin||tfn||'"'
   call lineout params.outfile,outlin
   call lineout params.outfile,' ALT="Thumbnail of '||filenam||'"'
   outlin='WIDTH='||width
   outlin=outlin 'HEIGHT='||height
   outlin=outlin 'BORDER='||params.border||'></A>'
   call lineout params.outfile, outlin
      
   call lineout params.outfile,''
   outlin='<br>'filenam 'size=' wbig '*' hbig
   outlin=outlin||';' filesize 'bytes'
   outlin=outlin||'<BR>Thumbnail scale ='||scalex
   call lineout params.outfile, outlin
    
   
   end

   i=i+1
   
   end  /* files loop */


return

jpgsize: procedure expose width height
/* JPGINFO.CMD */
/* JTdidit program to try to extract size of a JPG file */

parse arg fullname


width=''
height=''

xx=stream(fullname,'C','open read')
   if xx <> 'READY:' then do
      say "Can't open file" fullname
      return
      end

head=charin(fullname,,2)
if head<>'FFD8'X then do
   say fullname 'Not a JPG file'
   return
   end

do while chars(fullname)>0
   xx=charin(fullname,,2)
   if (xx>= "FFC0"X) & (xx<="FFC3"X) then do
      /* we have what we hope is the data frame */
      junk=charin(fullname,,3) /* pass over length and precision */
      hhex=charin(fullname,,2)
      whex=charin(fullname,,2)
      height= c2d(hhex)
      width= c2d(whex)
      call stream fullname,'C','CLOSE'

      return
      end
   else do
      xy=charin(fullname,,2)  /* get length */
      length=c2d(xy)
      junk=charin(fullname,,length-2)  /* skip over it */
      end
  end
  say 'No image segment found in file' fullname
  return



/* read params  */
readparms: procedure  expose params. parmfile

/*  we don't do this, anything not specified is default value params.='***' */
is=stream(parmfile,'c','open read')

do while lines(parmfile)
   line=strip(linein(parmfile))
   if line='' then iterate
   if left(line,2) = '/'||'*' then iterate
   if left(line,1) = ';' then iterate
   if left(line,1) = '#' then iterate
   parse var line parm '=' value
   parm=strip(translate(parm))
   params.parm=strip(value)
   end
is=stream(parmfile,'c','close')

return